//  Copyright(C):      Advanced Card Systems Ltd
//
//  File:              ACR120 AntennaPower And RWUPort Sample.csproj
//
//  Description:       AntennaPower And RWUPort sample code for 
//					   ACR120 USB Contactless Reader.
//
//  Author:	           Jose Isagani R. Mission
//
//  Date:	           August 16, 2006
//
//  Revision Trail:   (Date/Author/Description)
//                     December 11, 2007/ Aileen Grace L. Sarte/ Converted to Visual C# 2005
//
//===========================================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ACR120_AntennaPower_And_RWUPort_Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private int g_rHandle, g_retCode;
		private bool g_isConnected = false;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.GroupBox gbConnect;
		private System.Windows.Forms.GroupBox gbFunction;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cbPort;
		private System.Windows.Forms.Button btnAnteOn;
		private System.Windows.Forms.Button btnAnteOff;
		private System.Windows.Forms.Button btnReadPort;
		private System.Windows.Forms.Button btnWritePort;
		private System.Windows.Forms.ListBox lbMessage;
		private System.Windows.Forms.Button btnClrDisp;
		private System.Windows.Forms.CheckBox chbBuzzer;
		private System.Windows.Forms.CheckBox chbLED;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void DisplayMessage(string Message)
		{
			lbMessage.Items.Add(Message);	
			lbMessage.SelectedIndex = lbMessage.Items.Count - 1;
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.btnQuit = new System.Windows.Forms.Button();
            this.panel1 = new System.Windows.Forms.Panel();
            this.gbFunction = new System.Windows.Forms.GroupBox();
            this.chbLED = new System.Windows.Forms.CheckBox();
            this.chbBuzzer = new System.Windows.Forms.CheckBox();
            this.btnWritePort = new System.Windows.Forms.Button();
            this.btnReadPort = new System.Windows.Forms.Button();
            this.btnAnteOff = new System.Windows.Forms.Button();
            this.btnAnteOn = new System.Windows.Forms.Button();
            this.gbConnect = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.cbPort = new System.Windows.Forms.ComboBox();
            this.btnConnect = new System.Windows.Forms.Button();
            this.lbMessage = new System.Windows.Forms.ListBox();
            this.btnClrDisp = new System.Windows.Forms.Button();
            this.panel1.SuspendLayout();
            this.gbFunction.SuspendLayout();
            this.gbConnect.SuspendLayout();
            this.SuspendLayout();
            // 
            // btnQuit
            // 
            this.btnQuit.Location = new System.Drawing.Point(400, 376);
            this.btnQuit.Name = "btnQuit";
            this.btnQuit.Size = new System.Drawing.Size(112, 23);
            this.btnQuit.TabIndex = 9;
            this.btnQuit.Text = "&Quit";
            this.btnQuit.Click += new System.EventHandler(this.button1_Click);
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel1.Controls.Add(this.gbFunction);
            this.panel1.Controls.Add(this.gbConnect);
            this.panel1.Controls.Add(this.lbMessage);
            this.panel1.Location = new System.Drawing.Point(16, 16);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(496, 344);
            this.panel1.TabIndex = 1;
            // 
            // gbFunction
            // 
            this.gbFunction.Controls.Add(this.chbLED);
            this.gbFunction.Controls.Add(this.chbBuzzer);
            this.gbFunction.Controls.Add(this.btnWritePort);
            this.gbFunction.Controls.Add(this.btnReadPort);
            this.gbFunction.Controls.Add(this.btnAnteOff);
            this.gbFunction.Controls.Add(this.btnAnteOn);
            this.gbFunction.Location = new System.Drawing.Point(240, 184);
            this.gbFunction.Name = "gbFunction";
            this.gbFunction.Size = new System.Drawing.Size(240, 144);
            this.gbFunction.TabIndex = 2;
            this.gbFunction.TabStop = false;
            this.gbFunction.Text = "Functions";
            // 
            // chbLED
            // 
            this.chbLED.Location = new System.Drawing.Point(80, 104);
            this.chbLED.Name = "chbLED";
            this.chbLED.Size = new System.Drawing.Size(48, 24);
            this.chbLED.TabIndex = 6;
            this.chbLED.Text = "LED";
            // 
            // chbBuzzer
            // 
            this.chbBuzzer.Location = new System.Drawing.Point(16, 104);
            this.chbBuzzer.Name = "chbBuzzer";
            this.chbBuzzer.Size = new System.Drawing.Size(56, 24);
            this.chbBuzzer.TabIndex = 5;
            this.chbBuzzer.Text = "Buzzer";
            // 
            // btnWritePort
            // 
            this.btnWritePort.Location = new System.Drawing.Point(128, 104);
            this.btnWritePort.Name = "btnWritePort";
            this.btnWritePort.Size = new System.Drawing.Size(96, 23);
            this.btnWritePort.TabIndex = 7;
            this.btnWritePort.Text = "&Write User Port";
            this.btnWritePort.Click += new System.EventHandler(this.btnWritePort_Click);
            // 
            // btnReadPort
            // 
            this.btnReadPort.Location = new System.Drawing.Point(128, 64);
            this.btnReadPort.Name = "btnReadPort";
            this.btnReadPort.Size = new System.Drawing.Size(96, 23);
            this.btnReadPort.TabIndex = 4;
            this.btnReadPort.Text = "&Read User Port";
            this.btnReadPort.Click += new System.EventHandler(this.btnReadPort_Click);
            // 
            // btnAnteOff
            // 
            this.btnAnteOff.Location = new System.Drawing.Point(128, 24);
            this.btnAnteOff.Name = "btnAnteOff";
            this.btnAnteOff.Size = new System.Drawing.Size(96, 23);
            this.btnAnteOff.TabIndex = 3;
            this.btnAnteOff.Text = "Antenna &Off";
            this.btnAnteOff.Click += new System.EventHandler(this.btnAnteOff_Click);
            // 
            // btnAnteOn
            // 
            this.btnAnteOn.Location = new System.Drawing.Point(16, 24);
            this.btnAnteOn.Name = "btnAnteOn";
            this.btnAnteOn.Size = new System.Drawing.Size(96, 23);
            this.btnAnteOn.TabIndex = 2;
            this.btnAnteOn.Text = "&Antenna On";
            this.btnAnteOn.Click += new System.EventHandler(this.btnAnteOn_Click);
            // 
            // gbConnect
            // 
            this.gbConnect.Controls.Add(this.label1);
            this.gbConnect.Controls.Add(this.cbPort);
            this.gbConnect.Controls.Add(this.btnConnect);
            this.gbConnect.Location = new System.Drawing.Point(16, 184);
            this.gbConnect.Name = "gbConnect";
            this.gbConnect.Size = new System.Drawing.Size(208, 128);
            this.gbConnect.TabIndex = 1;
            this.gbConnect.TabStop = false;
            this.gbConnect.Text = "Connection";
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.ForeColor = System.Drawing.Color.Navy;
            this.label1.Location = new System.Drawing.Point(16, 34);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(72, 16);
            this.label1.TabIndex = 2;
            this.label1.Text = "Select Port";
            // 
            // cbPort
            // 
            this.cbPort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbPort.Location = new System.Drawing.Point(88, 32);
            this.cbPort.Name = "cbPort";
            this.cbPort.Size = new System.Drawing.Size(104, 21);
            this.cbPort.TabIndex = 0;
            // 
            // btnConnect
            // 
            this.btnConnect.Location = new System.Drawing.Point(96, 72);
            this.btnConnect.Name = "btnConnect";
            this.btnConnect.Size = new System.Drawing.Size(96, 23);
            this.btnConnect.TabIndex = 1;
            this.btnConnect.Text = "&Connect";
            this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
            // 
            // lbMessage
            // 
            this.lbMessage.Location = new System.Drawing.Point(16, 16);
            this.lbMessage.Name = "lbMessage";
            this.lbMessage.Size = new System.Drawing.Size(464, 160);
            this.lbMessage.TabIndex = 0;
            // 
            // btnClrDisp
            // 
            this.btnClrDisp.Location = new System.Drawing.Point(272, 376);
            this.btnClrDisp.Name = "btnClrDisp";
            this.btnClrDisp.Size = new System.Drawing.Size(112, 23);
            this.btnClrDisp.TabIndex = 8;
            this.btnClrDisp.Text = "Clear &Display";
            this.btnClrDisp.Click += new System.EventHandler(this.btnClrDisp_Click);
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
            this.ClientSize = new System.Drawing.Size(528, 413);
            this.Controls.Add(this.btnClrDisp);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.btnQuit);
            this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "MainForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "ACR120 AntennaPower And RWUPort Sample";
            this.Load += new System.EventHandler(this.MainForm_Load);
            this.panel1.ResumeLayout(false);
            this.gbFunction.ResumeLayout(false);
            this.gbConnect.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			ACR120U.ACR120_Close(g_rHandle);
			Application.Exit();
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
		
			//=====================================================================
			// This function opens the port(connection) to ACR120 reader
			//=====================================================================
		
			// Variable declarations
			int ctr = 0;
			byte[] FirmwareVer = new byte[31];
			byte[] FirmwareVer1 = new byte[20];
			byte infolen = 0x00;
			string FirmStr;
			ACR120U.tReaderStatus ReaderStat = new ACR120U.tReaderStatus();

			if (g_isConnected)
			{
			
				DisplayMessage("Device is already connected.");
				return;

			}

			g_rHandle = ACR120U.ACR120_Open(cbPort.SelectedIndex);
			if (g_rHandle != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_rHandle));
					
			else
			{
				
				DisplayMessage("Connected to USB" + string.Format("{0}", cbPort.SelectedIndex+1));
				g_isConnected = true;

				//Get the DLL version the program is using
				g_retCode = ACR120U.ACR120_RequestDLLVersion(ref infolen, ref FirmwareVer[0]);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen)-1;ctr++)
						FirmStr = FirmStr + char.ToString((char)(FirmwareVer[ctr]));
					DisplayMessage("DLL Version : " + FirmStr);
				}
    
				//Routine to get the firmware version.
				g_retCode = ACR120U.ACR120_Status(g_rHandle, ref FirmwareVer1[0], ref ReaderStat);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen);ctr++)
						if ((FirmwareVer1[ctr] != 0x00) && (FirmwareVer1[ctr] != 0xFF))
							FirmStr = FirmStr + char.ToString((char)(FirmwareVer1[ctr]));
					DisplayMessage("Firmware Version : " + FirmStr);
				}

			}

		}

		private void btnClrDisp_Click(object sender, System.EventArgs e)
		{
			lbMessage.Items.Clear();	
		}

		private void btnAnteOn_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			// This function turns the antenna power on
			//=====================================================================

			g_retCode = ACR120U.ACR120_Power(g_rHandle, 1);  
			if (g_retCode != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
				
				DisplayMessage("Antenna Power On Success: " + String.Format("{0}", g_retCode));

		}

		private void btnAnteOff_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			// This function turns the antenna power off
			//=====================================================================

			g_retCode = ACR120U.ACR120_Power(g_rHandle, 0); 
			if (g_retCode != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
				
				DisplayMessage("Antenna Power Off Success: " + String.Format("{0}", g_retCode));

   		}

		private void btnReadPort_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			//Read user port state, this means you are CHECKING for the state
			//of the buzzer and the LED light if its ON or OFF.
			//=====================================================================

			byte portstat = 0;

			g_retCode = ACR120U.ACR120_ReadUserPort(g_rHandle, ref portstat);
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				
				DisplayMessage("Read User Port Success");
				switch (Convert.ToInt16(portstat))
				{
					case 4:
						DisplayMessage("Buzzer ON  LED OFF: " + String.Format("{0:X2}", portstat));
						chbBuzzer.Checked = true;
						chbLED.Checked = false;
						break;
					case 64:
						DisplayMessage("Buzzer OFF  LED ON: " + String.Format("{0:X2}", portstat));
						chbBuzzer.Checked = false;
						chbLED.Checked = true;
						break;
					case 68:
						DisplayMessage("Buzzer ON  LED ON: " + String.Format("{0:X2}", portstat));
						chbBuzzer.Checked = true;
						chbLED.Checked = true;
						break;
					default:
						DisplayMessage("Buzzer OFF  LED OFF: " + String.Format("{0:X2}", portstat));
						chbBuzzer.Checked = false;
						chbLED.Checked = false;
						break;
				}

			}
    
		}

		private void btnWritePort_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			//Write user port state, this means you are ASSIGNING the state
			//of the buzzer and the LED light if its ON or OFF.
			//=====================================================================
			byte portState = 0x00;

			if ((chbBuzzer.Checked == true) && (chbLED.Checked == false))
			{
				portState = Convert.ToByte(4);
			}
			if ((chbBuzzer.Checked == false) && (chbLED.Checked == true))
			{
				portState = Convert.ToByte(64);
			}
			if ((chbBuzzer.Checked == true) && (chbLED.Checked == true))
			{
				portState = Convert.ToByte(68);
			}
			if ((chbBuzzer.Checked == false) && (chbLED.Checked == false))
			{
				portState = Convert.ToByte(0);
			}
    
			g_retCode = ACR120U.ACR120_WriteUserPort(g_rHandle, portState);
			if (g_retCode != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
				
				DisplayMessage("Write User Port Success");
			switch (Convert.ToInt16(portState))
			{
				case 4:
					DisplayMessage("Buzzer ON  LED OFF: " + String.Format("{0:X2}", portState));
					break;
				case 64:
					DisplayMessage("Buzzer OFF  LED ON: " + String.Format("{0:X2}", portState));
					break;
				case 68:
					DisplayMessage("Buzzer ON  LED ON: " + String.Format("{0:X2}", portState));
					break;
				default:
					DisplayMessage("Buzzer OFF  LED OFF: " + String.Format("{0:X2}", portState));
					break;
			}
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Form Initialization routine
			DisplayMessage("Program Ready");
			cbPort.Items.Add("USB1");
			cbPort.Items.Add("USB2");
			cbPort.Items.Add("USB3");
			cbPort.Items.Add("USB4");
			cbPort.Items.Add("USB5");
			cbPort.Items.Add("USB6");
			cbPort.Items.Add("USB7");
			cbPort.Items.Add("USB8");
			cbPort.SelectedIndex = 0;
		}

	}
}
