//  Copyright(C):      Advanced Card Systems Ltd
//
//  File:              ACR120 MultiTag Select Sample.csproj
//
//  Description:       MultiTag Select sample code for 
//					   ACR120 USB Contactless Reader.
//
//  Author:	           Jose Isagani R. Mission
//
//  Date:	           August 16, 2006
//
//  Revision Trail:   (Date/Author/Description)
//                     December 11, 2007/ Aileen Grace L. Sarte/ Converted to Visual C# 2005
//
//==========================================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ACR120_MultiTag_Select_Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private int g_rHandle, g_retCode;
		private byte g_Sec, g_SID;
		private byte[] g_pKey = new byte[6];
		private bool g_isConnected = false;

		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.ListBox lbMessage;
		private System.Windows.Forms.GroupBox gbConnect;
		private System.Windows.Forms.GroupBox gbFunction;
		private System.Windows.Forms.Button btnClrDisp;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cbPort;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Button btnLogin;
		private System.Windows.Forms.Button btnListTag;
		private System.Windows.Forms.Button btnMTSelect;
		private System.Windows.Forms.TextBox tSN1;
		private System.Windows.Forms.TextBox tSN2;
		private System.Windows.Forms.TextBox tSN3;
		private System.Windows.Forms.TextBox tSN4;
		private System.Windows.Forms.TextBox tSN5;
		private System.Windows.Forms.RadioButton rb4;
		private System.Windows.Forms.RadioButton rb7;
		private System.Windows.Forms.RadioButton rb10;
		private System.Windows.Forms.TextBox tSN6;
		private System.Windows.Forms.TextBox tSN7;
		private System.Windows.Forms.TextBox tSN8;
		private System.Windows.Forms.TextBox tSN9;
		private System.Windows.Forms.TextBox tSN10;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void DisplayMessage(string Message)
		{
			lbMessage.Items.Add(Message);
			lbMessage.SelectedIndex = lbMessage.Items.Count - 1;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.btnQuit = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.gbFunction = new System.Windows.Forms.GroupBox();
			this.rb10 = new System.Windows.Forms.RadioButton();
			this.rb7 = new System.Windows.Forms.RadioButton();
			this.rb4 = new System.Windows.Forms.RadioButton();
			this.tSN10 = new System.Windows.Forms.TextBox();
			this.tSN9 = new System.Windows.Forms.TextBox();
			this.tSN8 = new System.Windows.Forms.TextBox();
			this.tSN7 = new System.Windows.Forms.TextBox();
			this.tSN6 = new System.Windows.Forms.TextBox();
			this.tSN5 = new System.Windows.Forms.TextBox();
			this.btnMTSelect = new System.Windows.Forms.Button();
			this.tSN4 = new System.Windows.Forms.TextBox();
			this.tSN3 = new System.Windows.Forms.TextBox();
			this.tSN2 = new System.Windows.Forms.TextBox();
			this.tSN1 = new System.Windows.Forms.TextBox();
			this.btnListTag = new System.Windows.Forms.Button();
			this.gbConnect = new System.Windows.Forms.GroupBox();
			this.btnLogin = new System.Windows.Forms.Button();
			this.btnConnect = new System.Windows.Forms.Button();
			this.cbPort = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lbMessage = new System.Windows.Forms.ListBox();
			this.btnClrDisp = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.gbFunction.SuspendLayout();
			this.gbConnect.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnQuit
			// 
			this.btnQuit.Location = new System.Drawing.Point(400, 464);
			this.btnQuit.Name = "btnQuit";
			this.btnQuit.Size = new System.Drawing.Size(112, 23);
			this.btnQuit.TabIndex = 19;
			this.btnQuit.Text = "&Quit";
			this.btnQuit.Click += new System.EventHandler(this.btnQuit_Click);
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.gbFunction);
			this.panel1.Controls.Add(this.gbConnect);
			this.panel1.Controls.Add(this.lbMessage);
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(512, 440);
			this.panel1.TabIndex = 1;
			// 
			// gbFunction
			// 
			this.gbFunction.Controls.Add(this.rb10);
			this.gbFunction.Controls.Add(this.rb7);
			this.gbFunction.Controls.Add(this.rb4);
			this.gbFunction.Controls.Add(this.tSN10);
			this.gbFunction.Controls.Add(this.tSN9);
			this.gbFunction.Controls.Add(this.tSN8);
			this.gbFunction.Controls.Add(this.tSN7);
			this.gbFunction.Controls.Add(this.tSN6);
			this.gbFunction.Controls.Add(this.tSN5);
			this.gbFunction.Controls.Add(this.btnMTSelect);
			this.gbFunction.Controls.Add(this.tSN4);
			this.gbFunction.Controls.Add(this.tSN3);
			this.gbFunction.Controls.Add(this.tSN2);
			this.gbFunction.Controls.Add(this.tSN1);
			this.gbFunction.Controls.Add(this.btnListTag);
			this.gbFunction.Location = new System.Drawing.Point(240, 192);
			this.gbFunction.Name = "gbFunction";
			this.gbFunction.Size = new System.Drawing.Size(256, 232);
			this.gbFunction.TabIndex = 2;
			this.gbFunction.TabStop = false;
			this.gbFunction.Text = "Functions";
			// 
			// rb10
			// 
			this.rb10.Location = new System.Drawing.Point(56, 96);
			this.rb10.Name = "rb10";
			this.rb10.Size = new System.Drawing.Size(168, 24);
			this.rb10.TabIndex = 6;
			this.rb10.Text = "10-Byte Serial Number (HEX)";
			this.rb10.CheckedChanged += new System.EventHandler(this.rb10_CheckedChanged);
			// 
			// rb7
			// 
			this.rb7.Location = new System.Drawing.Point(56, 72);
			this.rb7.Name = "rb7";
			this.rb7.Size = new System.Drawing.Size(168, 24);
			this.rb7.TabIndex = 5;
			this.rb7.Text = "7-Byte Serial Number (HEX)";
			this.rb7.CheckedChanged += new System.EventHandler(this.rb7_CheckedChanged);
			// 
			// rb4
			// 
			this.rb4.Location = new System.Drawing.Point(56, 48);
			this.rb4.Name = "rb4";
			this.rb4.Size = new System.Drawing.Size(168, 24);
			this.rb4.TabIndex = 4;
			this.rb4.Text = "4-Byte Serial Number (HEX)";
			this.rb4.CheckedChanged += new System.EventHandler(this.rb4_CheckedChanged);
			// 
			// tSN10
			// 
			this.tSN10.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN10.Location = new System.Drawing.Point(192, 160);
			this.tSN10.MaxLength = 2;
			this.tSN10.Name = "tSN10";
			this.tSN10.Size = new System.Drawing.Size(32, 21);
			this.tSN10.TabIndex = 16;
			this.tSN10.Text = "FF";
			this.tSN10.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN10.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			// 
			// tSN9
			// 
			this.tSN9.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN9.Location = new System.Drawing.Point(152, 160);
			this.tSN9.MaxLength = 2;
			this.tSN9.Name = "tSN9";
			this.tSN9.Size = new System.Drawing.Size(32, 21);
			this.tSN9.TabIndex = 15;
			this.tSN9.Text = "FF";
			this.tSN9.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN9.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN9.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN9_KeyUp);
			// 
			// tSN8
			// 
			this.tSN8.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN8.Location = new System.Drawing.Point(112, 160);
			this.tSN8.MaxLength = 2;
			this.tSN8.Name = "tSN8";
			this.tSN8.Size = new System.Drawing.Size(32, 21);
			this.tSN8.TabIndex = 14;
			this.tSN8.Text = "FF";
			this.tSN8.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN8.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN8.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN8_KeyUp);
			// 
			// tSN7
			// 
			this.tSN7.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN7.Location = new System.Drawing.Point(72, 160);
			this.tSN7.MaxLength = 2;
			this.tSN7.Name = "tSN7";
			this.tSN7.Size = new System.Drawing.Size(32, 21);
			this.tSN7.TabIndex = 13;
			this.tSN7.Text = "FF";
			this.tSN7.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN7.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN7.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN7_KeyUp);
			// 
			// tSN6
			// 
			this.tSN6.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN6.Location = new System.Drawing.Point(32, 160);
			this.tSN6.MaxLength = 2;
			this.tSN6.Name = "tSN6";
			this.tSN6.Size = new System.Drawing.Size(32, 21);
			this.tSN6.TabIndex = 12;
			this.tSN6.Text = "FF";
			this.tSN6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN6.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN6.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN6_KeyUp);
			// 
			// tSN5
			// 
			this.tSN5.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN5.Location = new System.Drawing.Point(192, 128);
			this.tSN5.MaxLength = 2;
			this.tSN5.Name = "tSN5";
			this.tSN5.Size = new System.Drawing.Size(32, 21);
			this.tSN5.TabIndex = 11;
			this.tSN5.Text = "FF";
			this.tSN5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN5.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN5.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN5_KeyUp);
			// 
			// btnMTSelect
			// 
			this.btnMTSelect.Location = new System.Drawing.Point(80, 192);
			this.btnMTSelect.Name = "btnMTSelect";
			this.btnMTSelect.Size = new System.Drawing.Size(96, 23);
			this.btnMTSelect.TabIndex = 17;
			this.btnMTSelect.Text = "Multi Tag &Select";
			this.btnMTSelect.Click += new System.EventHandler(this.btnMTSelect_Click);
			// 
			// tSN4
			// 
			this.tSN4.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN4.Location = new System.Drawing.Point(152, 128);
			this.tSN4.MaxLength = 2;
			this.tSN4.Name = "tSN4";
			this.tSN4.Size = new System.Drawing.Size(32, 21);
			this.tSN4.TabIndex = 10;
			this.tSN4.Text = "FF";
			this.tSN4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN4.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN4.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN4_KeyUp);
			// 
			// tSN3
			// 
			this.tSN3.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN3.Location = new System.Drawing.Point(112, 128);
			this.tSN3.MaxLength = 2;
			this.tSN3.Name = "tSN3";
			this.tSN3.Size = new System.Drawing.Size(32, 21);
			this.tSN3.TabIndex = 9;
			this.tSN3.Text = "FF";
			this.tSN3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN3.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN3.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN3_KeyUp);
			// 
			// tSN2
			// 
			this.tSN2.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN2.Location = new System.Drawing.Point(72, 128);
			this.tSN2.MaxLength = 2;
			this.tSN2.Name = "tSN2";
			this.tSN2.Size = new System.Drawing.Size(32, 21);
			this.tSN2.TabIndex = 8;
			this.tSN2.Text = "FF";
			this.tSN2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN2.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN2.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN2_KeyUp);
			// 
			// tSN1
			// 
			this.tSN1.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tSN1.Location = new System.Drawing.Point(32, 128);
			this.tSN1.MaxLength = 2;
			this.tSN1.Name = "tSN1";
			this.tSN1.Size = new System.Drawing.Size(32, 21);
			this.tSN1.TabIndex = 7;
			this.tSN1.Text = "FF";
			this.tSN1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tSN1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tSN1_KeyPress);
			this.tSN1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tSN1_KeyUp);
			// 
			// btnListTag
			// 
			this.btnListTag.Location = new System.Drawing.Point(80, 16);
			this.btnListTag.Name = "btnListTag";
			this.btnListTag.Size = new System.Drawing.Size(96, 23);
			this.btnListTag.TabIndex = 3;
			this.btnListTag.Text = "List &Tag";
			this.btnListTag.Click += new System.EventHandler(this.btnListTag_Click);
			// 
			// gbConnect
			// 
			this.gbConnect.Controls.Add(this.btnLogin);
			this.gbConnect.Controls.Add(this.btnConnect);
			this.gbConnect.Controls.Add(this.cbPort);
			this.gbConnect.Controls.Add(this.label1);
			this.gbConnect.Location = new System.Drawing.Point(8, 192);
			this.gbConnect.Name = "gbConnect";
			this.gbConnect.Size = new System.Drawing.Size(216, 232);
			this.gbConnect.TabIndex = 1;
			this.gbConnect.TabStop = false;
			this.gbConnect.Text = "Connection";
			// 
			// btnLogin
			// 
			this.btnLogin.Location = new System.Drawing.Point(104, 120);
			this.btnLogin.Name = "btnLogin";
			this.btnLogin.Size = new System.Drawing.Size(96, 23);
			this.btnLogin.TabIndex = 2;
			this.btnLogin.Text = "&Login";
			this.btnLogin.Click += new System.EventHandler(this.btnLogin_Click);
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(104, 80);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.Size = new System.Drawing.Size(96, 23);
			this.btnConnect.TabIndex = 1;
			this.btnConnect.Text = "&Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// cbPort
			// 
			this.cbPort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbPort.Location = new System.Drawing.Point(88, 40);
			this.cbPort.Name = "cbPort";
			this.cbPort.Size = new System.Drawing.Size(112, 21);
			this.cbPort.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Navy;
			this.label1.Location = new System.Drawing.Point(16, 40);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Select Port";
			// 
			// lbMessage
			// 
			this.lbMessage.Location = new System.Drawing.Point(8, 8);
			this.lbMessage.Name = "lbMessage";
			this.lbMessage.Size = new System.Drawing.Size(488, 173);
			this.lbMessage.TabIndex = 0;
			// 
			// btnClrDisp
			// 
			this.btnClrDisp.Location = new System.Drawing.Point(272, 464);
			this.btnClrDisp.Name = "btnClrDisp";
			this.btnClrDisp.Size = new System.Drawing.Size(112, 23);
			this.btnClrDisp.TabIndex = 18;
			this.btnClrDisp.Text = "Clear &Display";
			this.btnClrDisp.Click += new System.EventHandler(this.btnClrDisp_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(528, 501);
			this.Controls.Add(this.btnClrDisp);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.btnQuit);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ACR120 MultiTag Select Sample";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			this.gbFunction.ResumeLayout(false);
			this.gbConnect.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void btnQuit_Click(object sender, System.EventArgs e)
		{
			ACR120U.ACR120_Close(g_rHandle);
			Application.Exit();
		}

		private void btnClrDisp_Click(object sender, System.EventArgs e)
		{
			lbMessage.Items.Clear();
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
		
			//=====================================================================
			// This function opens the port(connection) to ACR120 reader
			//=====================================================================
		
			// Variable declarations
			int ctr = 0;
			byte[] FirmwareVer = new byte[31];
			byte[] FirmwareVer1 = new byte[20];
			byte infolen = 0x00;
			string FirmStr;
			ACR120U.tReaderStatus ReaderStat = new ACR120U.tReaderStatus();

			if (g_isConnected)
			{
			
				DisplayMessage("Device is already connected.");
				return;

			}

			g_rHandle = ACR120U.ACR120_Open(cbPort.SelectedIndex);
			if (g_rHandle != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_rHandle));
					
			else
			{
				
				DisplayMessage("Connected to USB" + string.Format("{0}", cbPort.SelectedIndex+1));
				g_isConnected = true;

				//Get the DLL version the program is using
				g_retCode = ACR120U.ACR120_RequestDLLVersion(ref infolen, ref FirmwareVer[0]);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen)-1;ctr++)
						FirmStr = FirmStr + char.ToString((char)(FirmwareVer[ctr]));
					DisplayMessage("DLL Version : " + FirmStr);
				}
    
				//Routine to get the firmware version.
				g_retCode = ACR120U.ACR120_Status(g_rHandle, ref FirmwareVer1[0], ref ReaderStat);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen);ctr++)
						if ((FirmwareVer1[ctr] != 0x00) && (FirmwareVer1[ctr] != 0xFF))
							FirmStr = FirmStr + char.ToString((char)(FirmwareVer1[ctr]));
					DisplayMessage("Firmware Version : " + FirmStr);
				}

			}

		}

		private void btnLogin_Click(object sender, System.EventArgs e)
		{
			
			//=====================================================================
			// This function is for the authentication to access one sector of a card.
			// Only one sector at a time can be accessed.
			//=====================================================================
			
			long sto = 0;
			byte vKeyType = 0x00;
			int ctr, tmpInt, PhysicalSector = 0;

			Login loginForm = new Login();
			if (loginForm.ShowDialog() == DialogResult.Cancel)
				return;

			switch (loginForm.cbLoginType.SelectedIndex)
			{

				case 0: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_A;
					break;
				case 1: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_B;
					break;
				case 2: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_A;
					break;
				case 3: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_B;
					break;
				case 4: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_F;
					break;
				case 5: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_STORED_A;
					break;
				case 6: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_STORED_B;
					break;

			}

			switch (loginForm.cbLoginType.SelectedIndex)
			{

				case 0:
				case 1:
					g_pKey[0] = Convert.ToByte(loginForm.tKey1.Text  ,16);
					g_pKey[1] = Convert.ToByte(loginForm.tKey2.Text  ,16);
					g_pKey[2] = Convert.ToByte(loginForm.tKey3.Text  ,16);
					g_pKey[3] = Convert.ToByte(loginForm.tKey4.Text  ,16);
					g_pKey[4] = Convert.ToByte(loginForm.tKey5.Text  ,16);
					g_pKey[5] = Convert.ToByte(loginForm.tKey6.Text  ,16);
					break;
				case 2:
				case 3:
				case 4:
					for(ctr=0;ctr<6;ctr++)
						g_pKey[ctr] = 0xFF;
					break;
				case 5:
				case 6:
					sto = Convert.ToInt32(loginForm.tStoredNo.Text);
					break;
			
			}

			tmpInt = Convert.ToInt16(loginForm.tSector.Text);
			g_Sec = Convert.ToByte(tmpInt);

			//Computation for obtaining the actual Physical Sector.
			if (Convert.ToInt16(g_Sec) > 31)
				PhysicalSector = Convert.ToInt16(g_Sec) + ((Convert.ToInt16(g_Sec) - 32) * 3);
			else
				PhysicalSector = Convert.ToInt16(g_Sec);

			g_retCode = ACR120U.ACR120_Login(g_rHandle, Convert.ToByte(PhysicalSector), Convert.ToInt16(vKeyType),
				Convert.ToByte(sto), ref g_pKey[0]);
			if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Login Success");
				DisplayMessage("Log at Logical Sector: " + String.Format("{0}", Convert.ToInt16(g_Sec)));
				DisplayMessage("Log at Physical Sector: " + String.Format("{0}", PhysicalSector));
				DisplayMessage("Login Type index: " + string.Format("{0}", loginForm.cbLoginType.SelectedIndex));
			}

		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Form Initialization routine
			DisplayMessage("Program Ready");
			cbPort.Items.Add("USB1");
			cbPort.Items.Add("USB2");
			cbPort.Items.Add("USB3");
			cbPort.Items.Add("USB4");
			cbPort.Items.Add("USB5");
			cbPort.Items.Add("USB6");
			cbPort.Items.Add("USB7");
			cbPort.Items.Add("USB8");
			cbPort.SelectedIndex = 0;
			rb4.Checked =true;
			tSN5.Enabled = false;
			tSN6.Enabled = false;
			tSN7.Enabled = false;
			tSN8.Enabled = false;
			tSN9.Enabled = false;
			tSN10.Enabled = false;
		}

		private void tSN1_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar < 97 || e.KeyChar  > 102)
				if (e.KeyChar < 48 || e.KeyChar  > 57)
					if (e.KeyChar < 65 || e.KeyChar > 70)
						if (e.KeyChar != (char)(Keys.Back))
							e.Handled = true;
		}


		private void btnListTag_Click(object sender, System.EventArgs e)
		{
			//=====================================================================
			// This function list the serial number of all tags within the
			// readable antenna range
			//=====================================================================
    
			//Variable Declarations
			byte[] TagLength = new byte[51];
			byte TagFound = 0;
			byte[] TagType = new byte[51];
			byte[] SN = new byte[451];
			int ctr, ctr1, indx;
			string snstr;

			g_retCode = ACR120U.ACR120_ListTags(g_rHandle, ref TagFound, ref TagType[0], ref TagLength[0], ref SN[0]);
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{

				DisplayMessage("List Tag Success");
				DisplayMessage("Tag Found: " + String.Format("{0}", TagFound));
			
				// Parse the serial number array
				for(ctr1=0;ctr1<TagFound;ctr1++)
				{
					indx = ctr1 * 10;
					snstr = "";
					for(ctr=indx;ctr<(TagLength[ctr1]+indx);ctr++)
					{

						snstr = snstr + string.Format("{0:X2} ",SN[ctr]);

					}

					DisplayMessage("Tag(" + string.Format("{0}", ctr1) + ") : " + snstr + " ( " + ACR120U.GetTagType1(TagType[ctr1]) + " )");

				}
			}

		}

		private void btnMTSelect_Click(object sender, System.EventArgs e)
		{
			//=====================================================================
			// This function selects a single card in range and return the Serial No.
			//=====================================================================
    
			//Variable Declarations
			byte[] SerialNum = new byte[10];
			byte TagLength = 0x00, RTag = 0x00;
			byte[] RSn = new byte[10];
			byte[] TagType = new byte[51];
			string SN = "";
			int ctr;

			// Validate data entry
			if (tSN1.Text.Length < 2)
			{
				tSN1.Focus();
				return;
			}
			if (tSN2.Text.Length < 2)
			{
				tSN2.Focus();
				return;
			}
			if (tSN3.Text.Length < 2)
			{
				tSN3.Focus();
				return;
			}
			if (tSN4.Text.Length < 2)
			{
				tSN4.Focus();
				return;
			}

			SerialNum[0] = Convert.ToByte(tSN1.Text  ,16);
			SerialNum[1] = Convert.ToByte(tSN2.Text  ,16);
			SerialNum[2] = Convert.ToByte(tSN3.Text  ,16);
			SerialNum[3] = Convert.ToByte(tSN4.Text  ,16);
			TagLength = 0x04;

			if ((rb7.Checked == true) || (rb10.Checked == true))
			{
				if (tSN5.Text.Length < 2)
				{
					tSN5.Focus();
					return;
				}
				if (tSN6.Text.Length < 2)
				{
					tSN6.Focus();
					return;
				}
				if (tSN7.Text.Length < 2)
				{
					tSN7.Focus();
					return;
				}
				SerialNum[4] = Convert.ToByte(tSN5.Text  ,16);
				SerialNum[5] = Convert.ToByte(tSN6.Text  ,16);
				SerialNum[6] = Convert.ToByte(tSN7.Text  ,16);
				TagLength = 0x07;
			}
			if (rb10.Checked == true)
			{
				if (tSN8.Text.Length < 2)
				{
					tSN8.Focus();
					return;
				}
				if (tSN9.Text.Length < 2)
				{
					tSN9.Focus();
					return;
				}
				if (tSN10.Text.Length < 2)
				{
					tSN10.Focus();
					return;
				}
				SerialNum[7] = Convert.ToByte(tSN8.Text  ,16);
				SerialNum[8] = Convert.ToByte(tSN9.Text  ,16);
				SerialNum[9] = Convert.ToByte(tSN10.Text  ,16);
				TagLength = 0x0A;
			}

			//Select specific card based from serial number	
			g_retCode = ACR120U.ACR120_MultiTagSelect(g_rHandle, TagLength, ref SerialNum[0],
													  ref TagType[0], ref RTag, ref RSn[0]);
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Multi Tag Select Success");
				//get serial number of all cards detected by the reader and convert to hex

				SN = "";
				if ((TagType[0] == 0x04) ||(TagType[0] == 0x05))
				{
					for(ctr=0;ctr<7;ctr++)
						SN = SN + string.Format("{0:X2} ", RSn[ctr]);
				}
				else
				{
					for(ctr=0;ctr<Convert.ToInt16(TagLength);ctr++)
						SN = SN + string.Format("{0:X2} ", RSn[ctr]);
				}

				DisplayMessage("( i ) Card Serial Number: " + SN + " ( " + ACR120U.GetTagType1(TagType[0]) + " )");

			}

		}

		private void tSN1_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (tSN1.Text.Length == 2)
				tSN2.Focus(); 
		}

		private void tSN2_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (tSN2.Text.Length == 2)
				tSN3.Focus(); 
		}

		private void tSN3_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (tSN3.Text.Length == 2)
				tSN4.Focus(); 
		}

		private void rb4_CheckedChanged(object sender, System.EventArgs e)
		{
			tSN5.Enabled = false;
			tSN6.Enabled = false;
			tSN7.Enabled = false;
			tSN8.Enabled = false;
			tSN9.Enabled = false;
			tSN10.Enabled = false;
		}

		private void rb7_CheckedChanged(object sender, System.EventArgs e)
		{
			tSN5.Enabled = true;
			tSN6.Enabled = true;
			tSN7.Enabled = true;
			tSN8.Enabled = false;
			tSN9.Enabled = false;
			tSN10.Enabled = false;
		}

		private void rb10_CheckedChanged(object sender, System.EventArgs e)
		{
			tSN5.Enabled = true;
			tSN6.Enabled = true;
			tSN7.Enabled = true;
			tSN8.Enabled = true;
			tSN9.Enabled = true;
			tSN10.Enabled = true;

		}

		private void tSN4_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ((rb7.Checked == true) || (rb10.Checked == true))
			{
				if (tSN4.Text.Length == 2)
					tSN5.Focus();
			}
		}

		private void tSN5_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ((rb7.Checked == true) || (rb10.Checked == true))
			{
				if (tSN5.Text.Length == 2)
					tSN6.Focus();
			}
		}

		private void tSN6_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ((rb7.Checked == true) || (rb10.Checked == true))
			{
				if (tSN6.Text.Length == 2)
					tSN7.Focus();
			}
		}

		private void tSN7_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (rb10.Checked == true)
			{
				if (tSN7.Text.Length == 2)
					tSN8.Focus();
			}
		}

		private void tSN8_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (rb10.Checked == true)
			{
				if (tSN8.Text.Length == 2)
					tSN9.Focus();
			}
		}

		private void tSN9_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (rb10.Checked == true)
			{
				if (tSN9.Text.Length == 2)
					tSN10.Focus();
			}
		}

	}

}
