//  Copyright(C):      Advanced Card Systems Ltd
//
//  File:              ACR120 RW Block Sample.csproj
//
//  Description:       Read/Write Block sample code for 
//					   ACR120 USB Contactless Reader.
//
//  Author:	           Jose Isagani R. Mission
//
//  Date:	           August 16, 2006
//
//  Revision Trail:   (Date/Author/Description)
//                     December 11, 2007/ Aileen Grace L. Sarte/ Converted to Visual C# 2005
//
//===========================================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ACR120_RW_Block_Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{

        private int g_rHandle, g_retCode;
		public static byte g_Sec;
		private byte[] g_pKey = new byte[6];
		private bool g_isConnected = false;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.ListBox lbMessage;
		private System.Windows.Forms.GroupBox gbConnect;
		private System.Windows.Forms.GroupBox gbFunction;
		private System.Windows.Forms.Button btnClrDisp;
		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cbPort;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Button btnSelect;
		private System.Windows.Forms.Button btnLogin;
		private System.Windows.Forms.Button btnReadB;
		private System.Windows.Forms.Button btnWriteB;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void DisplayMessage(string Message)
		{
			lbMessage.Items.Add(Message);
			lbMessage.SelectedIndex = lbMessage.Items.Count - 1;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.gbFunction = new System.Windows.Forms.GroupBox();
			this.btnWriteB = new System.Windows.Forms.Button();
			this.btnReadB = new System.Windows.Forms.Button();
			this.gbConnect = new System.Windows.Forms.GroupBox();
			this.btnLogin = new System.Windows.Forms.Button();
			this.btnSelect = new System.Windows.Forms.Button();
			this.btnConnect = new System.Windows.Forms.Button();
			this.cbPort = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lbMessage = new System.Windows.Forms.ListBox();
			this.btnClrDisp = new System.Windows.Forms.Button();
			this.btnQuit = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.gbFunction.SuspendLayout();
			this.gbConnect.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.gbFunction);
			this.panel1.Controls.Add(this.gbConnect);
			this.panel1.Controls.Add(this.lbMessage);
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(528, 400);
			this.panel1.TabIndex = 0;
			// 
			// gbFunction
			// 
			this.gbFunction.Controls.Add(this.btnWriteB);
			this.gbFunction.Controls.Add(this.btnReadB);
			this.gbFunction.Location = new System.Drawing.Point(240, 192);
			this.gbFunction.Name = "gbFunction";
			this.gbFunction.Size = new System.Drawing.Size(272, 192);
			this.gbFunction.TabIndex = 2;
			this.gbFunction.TabStop = false;
			this.gbFunction.Text = "Functions";
			// 
			// btnWriteB
			// 
			this.btnWriteB.Location = new System.Drawing.Point(96, 120);
			this.btnWriteB.Name = "btnWriteB";
			this.btnWriteB.Size = new System.Drawing.Size(96, 23);
			this.btnWriteB.TabIndex = 1;
			this.btnWriteB.Text = "&Write Block";
			this.btnWriteB.Click += new System.EventHandler(this.btnWriteB_Click);
			// 
			// btnReadB
			// 
			this.btnReadB.Location = new System.Drawing.Point(96, 72);
			this.btnReadB.Name = "btnReadB";
			this.btnReadB.Size = new System.Drawing.Size(96, 23);
			this.btnReadB.TabIndex = 0;
			this.btnReadB.Text = "&Read Block";
			this.btnReadB.Click += new System.EventHandler(this.btnReadB_Click);
			// 
			// gbConnect
			// 
			this.gbConnect.Controls.Add(this.btnLogin);
			this.gbConnect.Controls.Add(this.btnSelect);
			this.gbConnect.Controls.Add(this.btnConnect);
			this.gbConnect.Controls.Add(this.cbPort);
			this.gbConnect.Controls.Add(this.label1);
			this.gbConnect.Location = new System.Drawing.Point(8, 192);
			this.gbConnect.Name = "gbConnect";
			this.gbConnect.Size = new System.Drawing.Size(224, 192);
			this.gbConnect.TabIndex = 1;
			this.gbConnect.TabStop = false;
			this.gbConnect.Text = "Connection";
			// 
			// btnLogin
			// 
			this.btnLogin.Location = new System.Drawing.Point(112, 152);
			this.btnLogin.Name = "btnLogin";
			this.btnLogin.Size = new System.Drawing.Size(96, 23);
			this.btnLogin.TabIndex = 4;
			this.btnLogin.Text = "&Login";
			this.btnLogin.Click += new System.EventHandler(this.btnLogin_Click);
			// 
			// btnSelect
			// 
			this.btnSelect.Location = new System.Drawing.Point(112, 112);
			this.btnSelect.Name = "btnSelect";
			this.btnSelect.Size = new System.Drawing.Size(96, 23);
			this.btnSelect.TabIndex = 3;
			this.btnSelect.Text = "&Select";
			this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(112, 72);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.Size = new System.Drawing.Size(96, 23);
			this.btnConnect.TabIndex = 2;
			this.btnConnect.Text = "&Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// cbPort
			// 
			this.cbPort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbPort.Location = new System.Drawing.Point(88, 32);
			this.cbPort.Name = "cbPort";
			this.cbPort.Size = new System.Drawing.Size(120, 21);
			this.cbPort.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Navy;
			this.label1.Location = new System.Drawing.Point(16, 37);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Select Port";
			this.label1.Click += new System.EventHandler(this.label1_Click);
			// 
			// lbMessage
			// 
			this.lbMessage.Location = new System.Drawing.Point(8, 8);
			this.lbMessage.Name = "lbMessage";
			this.lbMessage.Size = new System.Drawing.Size(507, 173);
			this.lbMessage.TabIndex = 0;
			// 
			// btnClrDisp
			// 
			this.btnClrDisp.Location = new System.Drawing.Point(280, 424);
			this.btnClrDisp.Name = "btnClrDisp";
			this.btnClrDisp.Size = new System.Drawing.Size(112, 23);
			this.btnClrDisp.TabIndex = 1;
			this.btnClrDisp.Text = "Clear &Display";
			this.btnClrDisp.Click += new System.EventHandler(this.btnClrDisp_Click);
			// 
			// btnQuit
			// 
			this.btnQuit.Location = new System.Drawing.Point(416, 424);
			this.btnQuit.Name = "btnQuit";
			this.btnQuit.Size = new System.Drawing.Size(112, 23);
			this.btnQuit.TabIndex = 2;
			this.btnQuit.Text = "&Quit";
			this.btnQuit.Click += new System.EventHandler(this.btnQuit_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(544, 462);
			this.Controls.Add(this.btnQuit);
			this.Controls.Add(this.btnClrDisp);
			this.Controls.Add(this.panel1);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Read/Write Block Sample";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			this.gbFunction.ResumeLayout(false);
			this.gbConnect.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void btnClrDisp_Click(object sender, System.EventArgs e)
		{
			lbMessage.Items.Clear();
		}

		private void btnQuit_Click(object sender, System.EventArgs e)
		{
			ACR120U.ACR120_Close(g_rHandle);
			Application.Exit();
		}

		private void label1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Form Initialization routine
			DisplayMessage("Program Ready");
			cbPort.Items.Add("USB1");
			cbPort.Items.Add("USB2");
			cbPort.Items.Add("USB3");
			cbPort.Items.Add("USB4");
			cbPort.Items.Add("USB5");
			cbPort.Items.Add("USB6");
			cbPort.Items.Add("USB7");
			cbPort.Items.Add("USB8");
			cbPort.SelectedIndex = 0;
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
		
			//=====================================================================
			// This function opens the port(connection) to ACR120 reader
			//=====================================================================
		
			// Variable declarations
			int ctr = 0;
			byte[] FirmwareVer = new byte[31];
			byte[] FirmwareVer1 = new byte[20];
			byte infolen = 0x00;
			string FirmStr;
			ACR120U.tReaderStatus ReaderStat = new ACR120U.tReaderStatus();

			if (g_isConnected)
			{
			
				DisplayMessage("Device is already connected.");
				return;

			}

			g_rHandle = ACR120U.ACR120_Open(cbPort.SelectedIndex);
			if (g_rHandle != 0)

				DisplayMessage("[X] Invalid Handle: " + String.Format("{0}", g_rHandle));
					
			else
			{
				
				DisplayMessage("Connected to USB" + string.Format("{0}", cbPort.SelectedIndex+1));
				g_isConnected = true;

				//Get the DLL version the program is using
				g_retCode = ACR120U.ACR120_RequestDLLVersion(ref infolen, ref FirmwareVer[0]);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen)-1;ctr++)
						FirmStr = FirmStr + char.ToString((char)(FirmwareVer[ctr]));
					DisplayMessage("DLL Version : " + FirmStr);
				}
    
				//Routine to get the firmware version.
				g_retCode = ACR120U.ACR120_Status(g_rHandle, ref FirmwareVer1[0], ref ReaderStat);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen);ctr++)
						if ((FirmwareVer1[ctr] != 0x00) && (FirmwareVer1[ctr] != 0xFF))
							FirmStr = FirmStr + char.ToString((char)(FirmwareVer1[ctr]));
					DisplayMessage("Firmware Version : " + FirmStr);
				}

			}

		}

		private void btnSelect_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			// This function selects a single card in range and return the Serial No.
			//=====================================================================
    
			//Variable Declarations
			byte[] ResultSN = new byte[11];
			byte ResultTag = 0x00;
			byte[] TagType = new byte[51];
			int ctr=0;
			string SN = "";


			//Select specific card based from serial number	
			g_retCode = ACR120U.ACR120_Select(g_rHandle, ref TagType[0], ref ResultTag, ref ResultSN[0]);
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Select Success");
				//get serial number and convert to hex
              
				if ((TagType[0] == 4) || (TagType[0] == 5))
				{

					SN = "";
					for (ctr=0; ctr<7;ctr++)
					{
						SN = SN + string.Format("{0:X2} ",ResultSN[ctr]);
					}

				}
				else
				{

					SN = "";
					for (ctr=0; ctr<ResultTag;ctr++)
					{
						SN = SN + string.Format("{0:X2} ",ResultSN[ctr]);
					}

				}
          
				//Display Serial Number
				DisplayMessage("( i ) Card Serial Number: " + SN + " ( " + ACR120U.GetTagType1(TagType[0]) + " )");
			}

		}

		private void btnLogin_Click(object sender, System.EventArgs e)
		{
			
			//=====================================================================
			// This function is for the authentication to access one sector of a card.
			// Only one sector at a time can be accessed.
			//=====================================================================
			
			long sto = 0;
			byte vKeyType = 0x00;
			int ctr, tmpInt, PhysicalSector = 0;

			Login loginForm = new Login();
			if (loginForm.ShowDialog() == DialogResult.Cancel)
				return;

			switch (loginForm.cbLoginType.SelectedIndex)
			{

				case 0: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_A;
					break;
				case 1: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_B;
					break;
				case 2: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_A;
					break;
				case 3: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_B;
					break;
				case 4: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_F;
					break;
				case 5: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_STORED_A;
					break;
				case 6: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_STORED_B;
					break;

			}

			switch (loginForm.cbLoginType.SelectedIndex)
			{

				case 0:
				case 1:
					g_pKey[0] = Convert.ToByte(loginForm.tKey1.Text  ,16);
					g_pKey[1] = Convert.ToByte(loginForm.tKey2.Text  ,16);
					g_pKey[2] = Convert.ToByte(loginForm.tKey3.Text  ,16);
					g_pKey[3] = Convert.ToByte(loginForm.tKey4.Text  ,16);
					g_pKey[4] = Convert.ToByte(loginForm.tKey5.Text  ,16);
					g_pKey[5] = Convert.ToByte(loginForm.tKey6.Text  ,16);
					break;
				case 2:
				case 3:
				case 4:
					for(ctr=0;ctr<6;ctr++)
						g_pKey[ctr] = 0xFF;
					break;
				case 5:
				case 6:
					sto = Convert.ToInt32(loginForm.tStoredNo.Text);
					break;
			
			}

			tmpInt = Convert.ToInt16(loginForm.tSector.Text);
			g_Sec = Convert.ToByte(tmpInt);

			//Computation for obtaining the actual Physical Sector.
			if (Convert.ToInt16(g_Sec) > 31)
				PhysicalSector = Convert.ToInt16(g_Sec) + ((Convert.ToInt16(g_Sec) - 32) * 3);
			else
				PhysicalSector = Convert.ToInt16(g_Sec);

			g_retCode = ACR120U.ACR120_Login(g_rHandle, Convert.ToByte(PhysicalSector), Convert.ToInt16(vKeyType),
				Convert.ToByte(sto), ref g_pKey[0]);
			if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Login Success");
				DisplayMessage("Log at Logical Sector: " + String.Format("{0}", Convert.ToInt16(g_Sec)));
				DisplayMessage("Log at Physical Sector: " + String.Format("{0}", PhysicalSector));
				DisplayMessage("Login Type index: " + string.Format("{0}", loginForm.cbLoginType.SelectedIndex));

			}

		}

		private void btnReadB_Click(object sender, System.EventArgs e)
		{

			//=======================================================================
			// This function reads a block within the sector where you login
			//=======================================================================

			//Variable Declarations
			byte[] dataRead = new byte[16];
			string dstr;
			int ctr, tmpInt = 0;
			byte Blck = 0;

			readForm readF = new readForm();
			if (readF.ShowDialog() == DialogResult.Cancel)
				return;

			Blck = Convert.ToByte(readF.tBlockNo.Text);
   
			//To access the exact block on the card you must Multiply Sector where you Login by 4
			//and add the Block.

			//Computation for exact block to Access
			tmpInt = Convert.ToInt16(Blck);
			if (Convert.ToInt16(g_Sec) > 31)
				tmpInt = tmpInt + ((Convert.ToInt16(g_Sec) - 32) * 16) + 128;
			else
				tmpInt = tmpInt + Convert.ToInt16(g_Sec) * 4;
			Blck = Convert.ToByte(tmpInt);

			g_retCode = ACR120U.ACR120_Read(g_rHandle, Blck, ref dataRead[0]);
            if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Read Block Success");
				// convert bytes read to chosen option (e.g. AS HEX, AS ASCII)
				dstr = "";
				for(ctr=0;ctr<16;ctr++)
				{
					if (readF.rbHex.Checked == true)
					{
						dstr = dstr + string.Format("{0:X2} ", dataRead[ctr]);
					}
					else
					{
						dstr = dstr + char.ToString((char)(dataRead[ctr]));
					}

				}

				DisplayMessage("Read Block " + String.Format("{0}", Blck) + ": " + dstr);

			}

		}

		private void btnWriteB_Click(object sender, System.EventArgs e)
		{

			//=======================================================================
			// This function writes a block within the sector where you login
			//=======================================================================

			//Variable Declarations
			int ctr, tmpInt = 0;
			byte Blck = 0;
			byte[] dout = new byte[16];
			char[] charArray = new char[16];
			string inStr;

			writeForm writeF = new writeForm();
			if (writeF.ShowDialog() == DialogResult.Cancel)
				return;

			//To access the exact block on the card 
			// For Sectors 0 - 31, you must Multiply Sector where you Login by 4 and add Block
			// For Sectors 32 - 38, you must Multiply Sector where you Login by 16 and add Block + 128
			Blck = Convert.ToByte(writeF.tBlockNo.Text);

			//Computation for exact block to Access
			//This is for Trapping Accidental write to block 3 (Sector < 32) or block 15 which is the Trailer Block
			//If your not sure on how to setup Access Bit or what to write on Trailer Block
			tmpInt = Convert.ToInt16(Blck);
			if (Convert.ToInt16(g_Sec) > 31)
			{
				if (Blck == 0x0F)
				{
					if (MessageBox.Show("Are you sure you want to write into the Trailer Block? If you do not want to modify your Access Bit, click Cancel.",
						"Trailer Block Write Confirmation", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation) == DialogResult.Cancel)
						return;
				}
				else
					tmpInt = tmpInt + ((Convert.ToInt16(g_Sec) - 32) * 16) + 128;
			}
			else
			{
				if (Blck == 0x03)
				{
					if (MessageBox.Show("Are you sure you want to write into the Trailer Block? If you do not want to modify your Access Bit, click Cancel.",
						"Trailer Block Write Confirmation", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation) == DialogResult.Cancel)
						return;
				}
				else
					tmpInt = tmpInt + Convert.ToInt16(g_Sec) * 4;
			}
			Blck = Convert.ToByte(tmpInt);

			// Convert input data
			if (writeF.rbHex.Checked == true)
			{
				if (writeF.tHexVal1.Text == "")
					dout[0] = 0x00;
				else
					dout[0] = Convert.ToByte(writeF.tHexVal1.Text  ,16);
				if (writeF.tHexVal2.Text == "")
					dout[1] = 0x00;
				else
					dout[1] = Convert.ToByte(writeF.tHexVal2.Text  ,16);
				if (writeF.tHexVal3.Text == "")
					dout[2] = 0x00;
				else
					dout[2] = Convert.ToByte(writeF.tHexVal3.Text  ,16);
				if (writeF.tHexVal4.Text == "")
					dout[3] = 0x00;
				else
					dout[3] = Convert.ToByte(writeF.tHexVal4.Text  ,16);
				if (writeF.tHexVal5.Text == "")
					dout[4] = 0x00;
				else
					dout[4] = Convert.ToByte(writeF.tHexVal5.Text  ,16);
				if (writeF.tHexVal6.Text == "")
					dout[5] = 0x00;
				else
					dout[5] = Convert.ToByte(writeF.tHexVal6.Text  ,16);
				if (writeF.tHexVal7.Text == "")
					dout[6] = 0x00;
				else
					dout[6] = Convert.ToByte(writeF.tHexVal7.Text  ,16);
				if (writeF.tHexVal8.Text == "")
					dout[7] = 0x00;
				else
					dout[7] = Convert.ToByte(writeF.tHexVal8.Text  ,16);
				if (writeF.tHexVal9.Text == "")
					dout[8] = 0x00;
				else
					dout[8] = Convert.ToByte(writeF.tHexVal9.Text  ,16);
				if (writeF.tHexVal10.Text == "")
					dout[9] = 0x00;
				else
					dout[9] = Convert.ToByte(writeF.tHexVal10.Text  ,16);
				if (writeF.tHexVal11.Text == "")
					dout[10] = 0x00;
				else
					dout[10] = Convert.ToByte(writeF.tHexVal11.Text  ,16);
				if (writeF.tHexVal12.Text == "")
					dout[11] = 0x00;
				else
					dout[11] = Convert.ToByte(writeF.tHexVal12.Text  ,16);
				if (writeF.tHexVal13.Text == "")
					dout[12] = 0x00;
				else
					dout[12] = Convert.ToByte(writeF.tHexVal13.Text  ,16);
				if (writeF.tHexVal14.Text == "")
					dout[13] = 0x00;
				else
					dout[13] = Convert.ToByte(writeF.tHexVal14.Text  ,16);
				if (writeF.tHexVal15.Text == "")
					dout[14] = 0x00;
				else
					dout[14] = Convert.ToByte(writeF.tHexVal15.Text  ,16);
				if (writeF.tHexVal16.Text == "")
					dout[15] = 0x00;
				else
					dout[15] = Convert.ToByte(writeF.tHexVal16.Text  ,16);
				inStr = "";
				for(ctr=0;ctr<16;ctr++)
				{
					inStr = inStr + String.Format("{0:X2} ", dout[ctr]);
				}

			}
			else
			{
				charArray = writeF.tAscVal.Text.ToCharArray();
				inStr = writeF.tAscVal.Text;
				for(ctr=0;ctr<writeF.tAscVal.Text.Length;ctr++)
				{
					dout[ctr] = Convert.ToByte(charArray[ctr]);
				}

			}

			g_retCode = ACR120U.ACR120_Write(g_rHandle, Blck, ref dout[0]);
			if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Write Block Success");
				DisplayMessage("Write Block " + String.Format("{0}", Blck) + ": "+ inStr);
			}

		}

	}
}
