//  Copyright(C):      Advanced Card Systems Ltd
//
//  File:              ACR120 RW EEPROM Sample.csproj
//
//  Description:       EEPROM Read/Write sample code for 
//					   ACR120 USB Contactless Reader.
//
//  Author:	           Jose Isagani R. Mission
//
//  Date:	           August 16, 2006
//
//  Revision Trail:   (Date/Author/Description)
//                     December 11, 2007/ Aileen Grace L. Sarte/ Converted to Visual C# 2005
//
//============================================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ACR120_RW_EEPROM_Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private int g_rHandle, g_retCode;
		private byte g_Sec;
		private bool g_isConnected = false;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnClrDisp;
		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.ListBox lbMessage;
		private System.Windows.Forms.GroupBox gbConnect;
		private System.Windows.Forms.GroupBox gbFunction;
		private System.Windows.Forms.ComboBox cbPort;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.TextBox tRegNo;
		private System.Windows.Forms.TextBox tValue;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btnRead;
		private System.Windows.Forms.Button btnWrite;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		private void DisplayMessage(string Message)
		{
			lbMessage.Items.Add(Message);	
			lbMessage.SelectedIndex = lbMessage.Items.Count - 1;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.gbFunction = new System.Windows.Forms.GroupBox();
			this.btnWrite = new System.Windows.Forms.Button();
			this.btnRead = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.tValue = new System.Windows.Forms.TextBox();
			this.tRegNo = new System.Windows.Forms.TextBox();
			this.gbConnect = new System.Windows.Forms.GroupBox();
			this.btnConnect = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.cbPort = new System.Windows.Forms.ComboBox();
			this.lbMessage = new System.Windows.Forms.ListBox();
			this.btnClrDisp = new System.Windows.Forms.Button();
			this.btnQuit = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.gbFunction.SuspendLayout();
			this.gbConnect.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.gbFunction);
			this.panel1.Controls.Add(this.gbConnect);
			this.panel1.Controls.Add(this.lbMessage);
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(528, 368);
			this.panel1.TabIndex = 0;
			// 
			// gbFunction
			// 
			this.gbFunction.Controls.Add(this.btnWrite);
			this.gbFunction.Controls.Add(this.btnRead);
			this.gbFunction.Controls.Add(this.label3);
			this.gbFunction.Controls.Add(this.label2);
			this.gbFunction.Controls.Add(this.tValue);
			this.gbFunction.Controls.Add(this.tRegNo);
			this.gbFunction.Location = new System.Drawing.Point(240, 192);
			this.gbFunction.Name = "gbFunction";
			this.gbFunction.Size = new System.Drawing.Size(272, 160);
			this.gbFunction.TabIndex = 2;
			this.gbFunction.TabStop = false;
			this.gbFunction.Text = "Functions";
			// 
			// btnWrite
			// 
			this.btnWrite.Location = new System.Drawing.Point(144, 112);
			this.btnWrite.Name = "btnWrite";
			this.btnWrite.Size = new System.Drawing.Size(104, 23);
			this.btnWrite.TabIndex = 6;
			this.btnWrite.Text = "&Write EEPROM";
			this.btnWrite.Click += new System.EventHandler(this.btnWrite_Click);
			// 
			// btnRead
			// 
			this.btnRead.Location = new System.Drawing.Point(24, 112);
			this.btnRead.Name = "btnRead";
			this.btnRead.Size = new System.Drawing.Size(104, 23);
			this.btnRead.TabIndex = 5;
			this.btnRead.Text = "&Read EEPROM";
			this.btnRead.Click += new System.EventHandler(this.btnRead_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(40, 72);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(96, 32);
			this.label3.TabIndex = 3;
			this.label3.Text = "Value to Write (Decimal)";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(40, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 32);
			this.label2.TabIndex = 2;
			this.label2.Text = "Register Number (Decimal)";
			// 
			// tValue
			// 
			this.tValue.Location = new System.Drawing.Point(160, 72);
			this.tValue.MaxLength = 3;
			this.tValue.Name = "tValue";
			this.tValue.Size = new System.Drawing.Size(96, 21);
			this.tValue.TabIndex = 4;
			this.tValue.Text = "0";
			this.tValue.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.tValue.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tRegNo_KeyPress);
			// 
			// tRegNo
			// 
			this.tRegNo.Location = new System.Drawing.Point(160, 32);
			this.tRegNo.MaxLength = 3;
			this.tRegNo.Name = "tRegNo";
			this.tRegNo.Size = new System.Drawing.Size(96, 21);
			this.tRegNo.TabIndex = 3;
			this.tRegNo.Text = "0";
			this.tRegNo.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.tRegNo.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tRegNo_KeyPress);
			// 
			// gbConnect
			// 
			this.gbConnect.Controls.Add(this.btnConnect);
			this.gbConnect.Controls.Add(this.label1);
			this.gbConnect.Controls.Add(this.cbPort);
			this.gbConnect.Location = new System.Drawing.Point(8, 192);
			this.gbConnect.Name = "gbConnect";
			this.gbConnect.Size = new System.Drawing.Size(224, 160);
			this.gbConnect.TabIndex = 1;
			this.gbConnect.TabStop = false;
			this.gbConnect.Text = "Connection";
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(112, 80);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.Size = new System.Drawing.Size(96, 23);
			this.btnConnect.TabIndex = 1;
			this.btnConnect.Text = "&Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Navy;
			this.label1.Location = new System.Drawing.Point(16, 37);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Select Port";
			// 
			// cbPort
			// 
			this.cbPort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbPort.Location = new System.Drawing.Point(88, 32);
			this.cbPort.Name = "cbPort";
			this.cbPort.Size = new System.Drawing.Size(120, 21);
			this.cbPort.TabIndex = 0;
			// 
			// lbMessage
			// 
			this.lbMessage.Location = new System.Drawing.Point(8, 8);
			this.lbMessage.Name = "lbMessage";
			this.lbMessage.Size = new System.Drawing.Size(507, 173);
			this.lbMessage.TabIndex = 0;
			// 
			// btnClrDisp
			// 
			this.btnClrDisp.Location = new System.Drawing.Point(280, 392);
			this.btnClrDisp.Name = "btnClrDisp";
			this.btnClrDisp.Size = new System.Drawing.Size(112, 23);
			this.btnClrDisp.TabIndex = 7;
			this.btnClrDisp.Text = "Clear &Display";
			this.btnClrDisp.Click += new System.EventHandler(this.btnClrDisp_Click);
			// 
			// btnQuit
			// 
			this.btnQuit.Location = new System.Drawing.Point(416, 392);
			this.btnQuit.Name = "btnQuit";
			this.btnQuit.Size = new System.Drawing.Size(112, 23);
			this.btnQuit.TabIndex = 8;
			this.btnQuit.Text = "&Quit";
			this.btnQuit.Click += new System.EventHandler(this.btnQuit_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(544, 429);
			this.Controls.Add(this.btnQuit);
			this.Controls.Add(this.btnClrDisp);
			this.Controls.Add(this.panel1);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Read/Write - EEPROM Sample";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			this.gbFunction.ResumeLayout(false);
			this.gbConnect.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void btnQuit_Click(object sender, System.EventArgs e)
		{
			ACR120U.ACR120_Close(g_rHandle);
			Application.Exit();
		}

		private void btnClrDisp_Click(object sender, System.EventArgs e)
		{
			lbMessage.Items.Clear();
		}
		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Form Initialization routine
			DisplayMessage("Program Ready");
			cbPort.Items.Add("USB1");
			cbPort.Items.Add("USB2");
			cbPort.Items.Add("USB3");
			cbPort.Items.Add("USB4");
			cbPort.Items.Add("USB5");
			cbPort.Items.Add("USB6");
			cbPort.Items.Add("USB7");
			cbPort.Items.Add("USB8");
			cbPort.SelectedIndex = 0;
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
		
			//=====================================================================
			// This function opens the port(connection) to ACR120 reader
			//=====================================================================
		
			// Variable declarations
			int ctr = 0;
			byte[] FirmwareVer = new byte[31];
			byte[] FirmwareVer1 = new byte[20];
			byte infolen = 0x00;
			string FirmStr;
			ACR120U.tReaderStatus ReaderStat = new ACR120U.tReaderStatus();

			if (g_isConnected)
			{
			
				DisplayMessage("Device is already connected.");
				return;

			}

			g_rHandle = ACR120U.ACR120_Open(cbPort.SelectedIndex);
			if (g_rHandle != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_rHandle));
					
			else
			{
				
				DisplayMessage("Connected to USB" + string.Format("{0}", cbPort.SelectedIndex+1));
				g_isConnected = true;

				//Get the DLL version the program is using
				g_retCode = ACR120U.ACR120_RequestDLLVersion(ref infolen, ref FirmwareVer[0]);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen)-1;ctr++)
						FirmStr = FirmStr + char.ToString((char)(FirmwareVer[ctr]));
					DisplayMessage("DLL Version : " + FirmStr);
				}
    
				//Routine to get the firmware version.
				g_retCode = ACR120U.ACR120_Status(g_rHandle, ref FirmwareVer1[0], ref ReaderStat);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen);ctr++)
						if ((FirmwareVer1[ctr] != 0x00) && (FirmwareVer1[ctr] != 0xFF))
							FirmStr = FirmStr + char.ToString((char)(FirmwareVer1[ctr]));
					DisplayMessage("Firmware Version : " + FirmStr);
				}

			}

		}

		private void btnRead_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			// This function reads the internal EEPROM of the ACR120 device
			//=====================================================================
    
			//Variable Declarations
			byte eePROMData = 0x00, reg = 0x00;
			int tmpInt = 0;

			tmpInt = Convert.ToInt16(tRegNo.Text);
			if (tmpInt > 255)
			{

				tRegNo.Text = "255";
				tRegNo.Focus();

			}
			else
				reg = (byte)tmpInt;

			g_retCode = ACR120U.ACR120_ReadEEPROM(g_rHandle, reg, ref eePROMData);

			if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{

				DisplayMessage("Read EEPROM Success");
				DisplayMessage("Read EEPROM Value of Register " + string.Format("{0}", reg) + " :" + string.Format("{0:X2}", eePROMData));

			}
			
		}

		private void btnWrite_Click(object sender, System.EventArgs e)
		{
			//=====================================================================
			// This function reads the internal EEPROM of the ACR120 device
			//=====================================================================
    
			//Variable Declarations
			byte eePROMData = 0x00, reg = 0x00;
			int tmpInt = 0;

			tmpInt = Convert.ToInt16(tRegNo.Text);
			if (tmpInt > 255)
			{

				tRegNo.Text = "255";
				tRegNo.Focus();

			}
			else
				reg = (byte)tmpInt;

			tmpInt = Convert.ToInt16(tValue.Text);
			if (tmpInt > 255)
			{

				tValue.Text = "255";
				tValue.Focus();

			}
			else
				eePROMData = (byte)tmpInt;

			g_retCode = ACR120U.ACR120_WriteEEPROM(g_rHandle, reg, eePROMData);

			if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{

				DisplayMessage("Write EEPROM Success");
				DisplayMessage("Write EEPROM Value of Register " + string.Format("{0}", reg) + " :" + string.Format("{0:X2}", eePROMData));

			}
			
		}

		private void tRegNo_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar < 48 || e.KeyChar  > 57)
				if (e.KeyChar != (char)(Keys.Back))
					e.Handled = true;
		}
	}
}
